package com.imcode.forum.shell;

import com.imcode.forum.*;

import java.io.PrintStream;

public class CreatePostCommand implements ForumShellCommand {

    public void execute(ForumRepository repository, PrintStream out, String[] commandParameters) {
        int forumId = Integer.parseInt(commandParameters[0]);
        int threadId = Integer.parseInt(commandParameters[1]);
        int postId = Integer.parseInt(commandParameters[2]);
        Forum forum = repository.getForum(repository.createId(forumId));
        ForumThread thread = forum.getThread(repository.createId(threadId));
        ForumPost post = thread.getPost(repository.createId(postId));
        SimpleForumPost newReply = new SimpleForumPost("reply to "+post.getTitle(), "reply to "+post.getBody(), null);
        Id replyId = post.createReply(newReply);
        ForumPost reply = thread.getPost(replyId);
        out.println("Created " + reply);
    }

    public String[] getParameterNames() {
        return new String[] { "forum-id", "thread-id", "post-id" };
    }

    public String getPurpose() {
        return "Create post" ;
    }
}
