package com.imcode.forum.sql;

import com.imcode.forum.Forum;
import com.imcode.forum.ForumThread;
import com.imcode.forum.ForumPost;
import com.imcode.forum.Id;

import java.util.List;
import java.util.Date;

class SqlForum implements Forum {

    private final Id id;
    private final SqlRepository forumRepository;

    SqlForum(SqlRepository forumRepository, Id id) {
        this.id = id;
        this.forumRepository = forumRepository;
    }

    public List<ForumThread> getThreads() {
        return forumRepository.getForumThreads(id) ;
    }

    public ForumThread createThread(ForumPost post) {
        return forumRepository.createThread(id, post) ;
    }

    public Id getId() {
        return id ;
    }

    public ForumThread getThread(Id id) {
        return forumRepository.getThread(id) ;
    }

    public String toString() {
        return "forum "+id+" in repository "+forumRepository ;
    }
}
