package com.imcode.forum.sql;

import org.apache.commons.lang.NullArgumentException;
import com.imcode.forum.Id;

class SqlId implements Id {

    private final Long value;

    SqlId(Number value) {
        if (null == value) {
            throw new NullArgumentException("value") ;
        }
        this.value = value.longValue() ;
    }

    public Object getValue() {
        return value ;
    }

    public boolean equals(Object o) {
        if ( this == o ) {
            return true;
        }
        if ( o == null || getClass() != o.getClass() ) {
            return false;
        }
        SqlId other = (SqlId) o;
        return value.longValue() == other.value.longValue() ;
    }

    public int hashCode() {
        return value.intValue() ;
    }

    public String toString() {
        return ""+value ;
    }

}