package com.imcode.forum.sql;

import com.imcode.forum.ForumPost;
import com.imcode.forum.Id;

import java.util.Date;
import java.util.SortedSet;
import java.util.Calendar;

class SqlPost implements ForumPost {

    private String title;
    private String user;
    private Date dateTime = new Date();
    private String body;
    private int viewCount;
    private SqlThread thread;
    private final Id id;
    private Id parentPostId;
    private boolean hidden;

    SqlPost(Id id, SqlThread thread) {
        this.id = id;
        this.thread = thread;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public String getTitle() {
        return title;
    }

    public String getUser() {
        return user;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public Date getDateTime() {
        return (Date) dateTime.clone();
    }

    public String getBody() {
        return body;
    }

    public boolean isHidden() {
        return hidden ;
    }

    public void hide(boolean hidden) {
        thread.hidePost(id, hidden) ;
        setHidden(hidden) ;
    }

    public void setBody(String body) {
        this.body = body;
    }

    public SortedSet<ForumPost> getReplies() {
        return thread.getPostReplies(this) ;
    }

    public void incrementViewCount() {
        thread.incrementPostViewCount(id) ;
        viewCount++ ;
    }

    public String toString() {
        return "post "+id+" '"+title+"' created at "+dateTime ;
    }

    public void setDateTime(Date dateTime) {
        this.dateTime = (Date) dateTime.clone() ;
    }

    public void setViewCount(int viewCount) {
        this.viewCount = viewCount;
    }

    public int getViewCount() {
        return viewCount;
    }

    public Id createReply(ForumPost forumPost) {
        return thread.createPostReply(id, forumPost) ;
    }

    public Id getId() {
        return id;
    }

    public Id getParentPostId() {
        return parentPostId;
    }

    public void setParentPostId(SqlId parentPostId) {
        this.parentPostId = parentPostId;
    }

    public void setHidden(boolean hidden) {
        this.hidden = hidden;
    }
}
